package de.ozgcloud.eingang.common.zufi;

import static org.assertj.core.api.Assertions.*;
import static org.mockito.ArgumentMatchers.*;
import static org.mockito.Mockito.*;

import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.DisplayName;
import org.junit.jupiter.api.Nested;
import org.junit.jupiter.api.Test;
import org.mockito.InjectMocks;
import org.mockito.Mock;

class ZufiServiceTest {

	@InjectMocks
	private ZufiService service;
	@Mock
	private OrganisationsEinheitRemoteService remoteService;

	@DisplayName("Get vorgangManager url")
	@Nested
	class TestGetVorgangManagerUrl {

		private final OrganisationsEinheit organisationsEinheit = OrganisationsEinheitTestFactory.create();

		@BeforeEach
		void mock() {
			when(remoteService.getById(any())).thenReturn(organisationsEinheit);
		}

		@Test
		void shouldCallRemoteService() {
			service.getVorgangManagerUrl(OrganisationsEinheitTestFactory.ID);

			verify(remoteService).getById(OrganisationsEinheitTestFactory.ID);
		}

		@Test
		void shouldReturnValue() {
			var vorgangManagerAddress = service.getVorgangManagerUrl(OrganisationsEinheitTestFactory.ID);

			assertThat(vorgangManagerAddress).isEqualTo(OrganisationsEinheitTestFactory.VORGANG_MANAGER_ADDRESS);
		}
	}
}