package de.ozgcloud.eingang.semantik.enginebased.afm;

import static de.ozgcloud.eingang.semantik.enginebased.afm.ZustaendigeStelleMetadataMapper.*;

import java.util.List;
import java.util.Map;

import de.ozgcloud.eingang.semantik.enginebased.afm.ZustaendigeStelleData.ZustaendigeStelleDataBuilder;

public class ZustaendigeStelleDataTestFactory {
	public static final String BEHOERDE_ANZEIGE_NAME = "Landratsamt XYZ (Testbehörde für BDA)";
	public static final String BEHOERDE_CALLER_ID = "87331322433";
	public static final String GEMEINDE_SCHLUESSEL_BP = "09189155";
	public static final String BEHOERDE_EMAIL = "poststelle@testbehoerde.bayern";
	public static final String AMTLICHER_REGIONALSCHLUESSEL = "091890000000";
	public static final String BEHOERDE_HAUSANSCHRIFT_STRASSE = "Teststraße 1";
	public static final String BEHOERDE_HAUSANSCHRIFT_ORT = "Musterstadt";
	public static final String BEHOERDE_HAUSANSCHRIFT_PLZ = "12345";
	public static final String BEHOERDE_TELEFON = "+49 123 45-0";

	public static final Map<String, String> BEHOERDE_METADATA = Map.of(
			KEY_BEHOERDE_ANZEIGE_NAME, BEHOERDE_ANZEIGE_NAME,
			KEY_BEHOERDE_CALLER_ID, BEHOERDE_CALLER_ID,
			KEY_GEMEINDE_SCHLUESSEL_BP, GEMEINDE_SCHLUESSEL_BP,
			KEY_BEHOERDE_EMAIL, BEHOERDE_EMAIL,
			KEY_AMTLICHER_REGIONALSCHLUESSEL, AMTLICHER_REGIONALSCHLUESSEL,
			KEY_BEHOERDE_HAUSANSCHRIFT_STRASSE, BEHOERDE_HAUSANSCHRIFT_STRASSE,
			KEY_BEHOERDE_HAUSANSCHRIFT_ORT, BEHOERDE_HAUSANSCHRIFT_ORT,
			KEY_BEHOERDE_HAUSANSCHRIFT_PLZ, BEHOERDE_HAUSANSCHRIFT_PLZ,
			KEY_BEHOERDE_TELEFON, BEHOERDE_TELEFON
	);

	public static final List<ZustaendigeStelleData.Field> ZUSTAENDIGE_STELLE_DATA_FIELDS = List.of(
			ZustaendigeStelleMetadataFieldTestFactory.createBuilder().name(KEY_BEHOERDE_ANZEIGE_NAME)
					.value(ZustaendigeStelleDataTestFactory.BEHOERDE_ANZEIGE_NAME).build(),
			ZustaendigeStelleMetadataFieldTestFactory.createBuilder().name(KEY_BEHOERDE_CALLER_ID)
					.value(ZustaendigeStelleDataTestFactory.BEHOERDE_CALLER_ID).build(),
			ZustaendigeStelleMetadataFieldTestFactory.createBuilder().name(KEY_GEMEINDE_SCHLUESSEL_BP)
					.value(ZustaendigeStelleDataTestFactory.GEMEINDE_SCHLUESSEL_BP).build(),
			ZustaendigeStelleMetadataFieldTestFactory.createBuilder().name(KEY_BEHOERDE_EMAIL).value(ZustaendigeStelleDataTestFactory.BEHOERDE_EMAIL)
					.build(),
			ZustaendigeStelleMetadataFieldTestFactory.createBuilder().name(KEY_AMTLICHER_REGIONALSCHLUESSEL)
					.value(ZustaendigeStelleDataTestFactory.AMTLICHER_REGIONALSCHLUESSEL).build(),
			ZustaendigeStelleMetadataFieldTestFactory.createBuilder().name(KEY_BEHOERDE_HAUSANSCHRIFT_STRASSE)
					.value(ZustaendigeStelleDataTestFactory.BEHOERDE_HAUSANSCHRIFT_STRASSE).build(),
			ZustaendigeStelleMetadataFieldTestFactory.createBuilder().name(KEY_BEHOERDE_HAUSANSCHRIFT_ORT)
					.value(ZustaendigeStelleDataTestFactory.BEHOERDE_HAUSANSCHRIFT_ORT).build(),
			ZustaendigeStelleMetadataFieldTestFactory.createBuilder().name(KEY_BEHOERDE_HAUSANSCHRIFT_PLZ)
					.value(ZustaendigeStelleDataTestFactory.BEHOERDE_HAUSANSCHRIFT_PLZ).build(),
			ZustaendigeStelleMetadataFieldTestFactory.createBuilder().name(KEY_BEHOERDE_TELEFON).value(ZustaendigeStelleDataTestFactory.BEHOERDE_TELEFON)
					.build()
	);

	public static ZustaendigeStelleData create() {
		return createBuilder().build();
	}

	public static ZustaendigeStelleDataBuilder createBuilder() {
		return ZustaendigeStelleData.builder()
				.fields(ZUSTAENDIGE_STELLE_DATA_FIELDS);
	}
}
